
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/aut_to_exp.hh>
%}
%define alg_aut_to_exp_interface(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static Exp aut_to_exp(const GenAutomaton& a) ;
static Exp aut_to_exp(const GenAutomaton& a, const vcsn::DMChooser& b) ;
%enddef
%define alg_aut_to_exp_interface_impl(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static  Exp aut_to_exp(const GenAutomaton& a) { return vcsn::aut_to_exp(*a); }
static  Exp aut_to_exp(const GenAutomaton& a, const vcsn::DMChooser& b) { return vcsn::aut_to_exp(*a, b); }
%enddef
%define alg_interface_aut_to_exp(Kind)
%{
struct Kind ##_alg_aut_to_exp {
alg_aut_to_exp_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
%enddef
%define decl_alg_aut_to_exp(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_aut_to_exp {
alg_aut_to_exp_interface_impl(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
struct Kind ##_alg_aut_to_exp {
alg_aut_to_exp_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t,
			std::list<int>,
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%enddef
