
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/cut_up.hh>
%}
%define alg_cut_up_interface(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static bool is_cut_up(const Automaton& a) ;
static Automaton cut_up(const Automaton& a) ;
static void cut_up(const Automaton& a, Automaton& res) ;
%enddef
%define alg_cut_up_interface_impl(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static  bool is_cut_up(const Automaton& a) { return vcsn::is_cut_up(*a); }
static  Automaton cut_up(const Automaton& a) { return vcsn::cut_up(*a); }
static  void cut_up(const Automaton& a, Automaton& res) { vcsn::cut_up(*a, *res); }
%enddef
%define alg_interface_cut_up(Kind)
%{
struct Kind ##_alg_cut_up {
alg_cut_up_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
%enddef
%define decl_alg_cut_up(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_cut_up {
alg_cut_up_interface_impl(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
struct Kind ##_alg_cut_up {
alg_cut_up_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t,
			std::list<int>,
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%enddef
