
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/eps_removal_sp.hh>
%}
%define alg_eps_removal_sp_interface(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static void forward_eps_removal_here_sp(Automaton& a) ;
static Automaton forward_eps_removal_sp(const Automaton& a) ;
static void backward_eps_removal_here_sp(Automaton& a) ;
static Automaton backward_eps_removal_sp(const Automaton& a) ;
static void eps_removal_here_sp(Automaton& a, vcsn::misc::direction_type dir) ;
static Automaton eps_removal_sp(const Automaton& a, vcsn::misc::direction_type dir) ;
%enddef
%define alg_eps_removal_sp_interface_impl(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static  void forward_eps_removal_here_sp(Automaton& a) { return vcsn::forward_eps_removal_here(*a); }
static  Automaton forward_eps_removal_sp(const Automaton& a) { return vcsn::forward_eps_removal(*a); }
static  void backward_eps_removal_here_sp(Automaton& a) { return vcsn::backward_eps_removal_here(*a); }
static  Automaton backward_eps_removal_sp(const Automaton& a) { return vcsn::backward_eps_removal(*a); }
static  void eps_removal_here_sp(Automaton& a, vcsn::misc::direction_type dir) { return vcsn::eps_removal_here(*a); }
static  Automaton eps_removal_sp(const Automaton& a, vcsn::misc::direction_type dir) { return vcsn::eps_removal(*a); }
%enddef
%define alg_interface_eps_removal_sp(Kind)
%{
struct Kind ##_alg_eps_removal_sp {
alg_eps_removal_sp_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
%enddef
%define decl_alg_eps_removal_sp(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_eps_removal_sp {
alg_eps_removal_sp_interface_impl(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
struct Kind ##_alg_eps_removal_sp {
alg_eps_removal_sp_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t,
			std::list<int>,
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%enddef
