
%include vaucanswig_algo_common.i
%{
#include <vaucanson/algorithms/realtime.hh>
%}
%define alg_realtime_interface(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static bool is_realtime(const Automaton& a) ;
static bool is_realtime(const GenAutomaton& a) ;
static Automaton realtime(const Automaton& a) ;
static GenAutomaton realtime(const GenAutomaton& a) ;
%enddef
%define alg_realtime_interface_impl(Automaton, GenAutomaton, Series, Exp, HList, Word, Letter)
static  bool is_realtime(const Automaton& a) { return vcsn::is_realtime(*a); }
static  bool is_realtime(const GenAutomaton& a) { return vcsn::is_realtime(*a); }
static  Automaton realtime(const Automaton& a) { return vcsn::realtime(*a); }
static  GenAutomaton realtime(const GenAutomaton& a) { return vcsn::realtime(*a); }
%enddef
%define alg_interface_realtime(Kind)
%{
struct Kind ##_alg_realtime {
alg_realtime_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
%enddef
%define decl_alg_realtime(Kind)
algo_common_decls(Kind)
%{
struct Kind ##_alg_realtime {
alg_realtime_interface_impl(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t, \
			std::list<int>, \
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%}
struct Kind ##_alg_realtime {
alg_realtime_interface(Kind ##_types::Kind ##_auto_t, \
			Kind ##_types::gen_## Kind ##_auto_t, \
			Kind ##_types::Kind ##_series_set_elt_t, \
			Kind ##_types::Kind ##_exp_t,
			std::list<int>,
			std::basic_string<Kind ##_types::Kind ##_letter_t>, \
			Kind ##_types::Kind ##_letter_t)
};
%enddef
